package xvs.ACL;


import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.nio.Buffer;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import android.graphics.Bitmap;
import android.graphics.Bitmap.CompressFormat;
import android.graphics.Bitmap.Config;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.ImageFormat;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.PointF;
import android.graphics.Rect;
import android.graphics.YuvImage;
import android.hardware.Camera;
import android.hardware.Camera.AutoFocusCallback;
import android.hardware.Camera.Parameters;
import android.hardware.Camera.PreviewCallback;
import android.hardware.Camera.Size;
import android.media.FaceDetector;
import android.media.FaceDetector.Face;
import android.media.MediaRecorder;
import android.os.Environment;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;

/**
 * The new, improved camera library has a lot of new functions! These include:
 * flashlight, scene modes, orientations, front- and back camera, picture size,
 * white balance and a lot more! Only one process can access the camera at any
 * time. Therefore it is highly recommended to initialize the camera object in
 * Activity_Resume and release it in Activity_Pause. A working example with
 * explanations is available
 * <link>here|http://www.basic4ppc.com/forum/basic4android
 * -getting-started-tutorials/6891-take-pictures-internal-camera.html</link>.
 */
@ActivityObject
@Permissions(values = { "android.permission.CAMERA",
		"android.permission.WRITE_EXTERNAL_STORAGE",
		"android.permission.RECORD_AUDIO", "android.permission.FLASHLIGHT",
		"android.permission.RECORD_VIDEO","android.permission.WRITE_SECURE_SETTINGS","android.permission.BLUETOOTH", "android.permission.BLUETOOTH_ADMIN", "android.permission.INTERNET" })
@ShortName("AdvancedCamera")
@Version(4.4f)
@Author("XverhelstX")
@Events(values = { "Ready (Success As Boolean)",
		"PictureTaken (Data() As Byte)" })
public class ACL implements PreviewCallback {
	private byte[] CurrentJPEG;
	private static Camera c;
	HttpClient httpclient = new DefaultHttpClient();
	private SurfaceView sv;
	private String eventName;
	private BA ba;
	private AtomicInteger readyCount = new AtomicInteger();
	private boolean isPreviewOn = false;
	private boolean isDecoding = false;
	private boolean isRecording = false;
	private boolean mAvailableFrame = false;
	private int FrameWidth;
	private int FrameHeight;
	private int FrameQuality;
	private int addMarktoJPG;
	static final int REQUEST_ENABLE_BT = 0;
	private int CAMERA_FACING_FRONT;
	public String FrameProtect;
	InputStream is;
	
	private float FDeyedistance;
	private float FDconfidence;
	private int FDdetectedfaces;
	private float FDpose;
	private float FDmidpointx;
	private float FDmidpointy;
	public static final int EULER_X = 0;
	public static final int EULER_Y = 1;
	public static final int EULER_Z = 2;
	private float   mPoseEulerX;
	private float   mPoseEulerY;
	private float   mPoseEulerZ;
	

	/**
     * Initializes the camera.
     *Panel - The preview images will be displayed on the panel.
     *EventName - Events subs prefix.
     *The Ready event will be raised when the camera has finished opening.
     */
    @SuppressWarnings("static-access")
	public void Initialize(final BA ba, ViewGroup Panel, String EventName) {
        this.ba = ba;
        readyCount.set(0);
        this.eventName = EventName.toLowerCase(BA.cul);
        sv = new SurfaceView(ba.context);
        anywheresoftware.b4a.BALayout.LayoutParams lp = new anywheresoftware.b4a.BALayout.LayoutParams(0, 0,
                Panel.getLayoutParams().width, Panel.getLayoutParams().height);
        Panel.addView(sv, lp);
        if (c != null) {
            readyCount.set(1);
        }
        sv.getHolder().setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
        sv.getHolder().setFixedSize(Panel.getLayoutParams().width, Panel.getLayoutParams().height);
        sv.getHolder().addCallback(new SurfaceHolder.Callback() {

            @Override
            public void surfaceChanged(SurfaceHolder holder, int format,
                    int width, int height) {
            }

            @Override
            public void surfaceCreated(SurfaceHolder holder) {
                if (readyCount.addAndGet(1) == 2) {
                    ba.raiseEvent(null, eventName + "_ready", true);
                }
            }

            @Override
            public void surfaceDestroyed(SurfaceHolder holder) {

            }

        });
        if (c == null) {
            ba.submitRunnable(new Runnable() {

                @Override
                public void run() {
                    try {
                        c = Camera.open();
                        if (readyCount.addAndGet(1) == 2) {
                            ba.raiseEventFromDifferentThread(null, ACL.this, -1,eventName +  "_ready", false, new Object[] {true});
                        }
                    }
                    catch (Exception e) {
                        Release();
                        ba.raiseEventFromDifferentThread(null, ACL.this, -1,eventName +  "_ready", false, new Object[] {false});
                    }
                }

            }, this, -1);
        }
    }

    /**
	 * Starts displaying the preview images.
	 * 
	 * @throws IOException
	 */
	public void StartPreview() throws IOException {
			isPreviewOn = true;
			c.setPreviewDisplay(sv.getHolder());
	        c.startPreview();
			
	}

	/**
	 * Stops displaying the preview images.
	 */
	public void StopPreview() {
			isPreviewOn = false;
			if (c != null)
	            c.stopPreview();
			
	}
	
	MediaRecorder m_recorder = new MediaRecorder();

	/**
	 * Initialize the video recorder. Filename as string Duration as integer,
	 * Width as integer, Height as integer, FrameRate as integer. Files are
	 * saved on sdcard as Filename.mp4
	 */
	public void initRecorder(String Filename, int Duration, int Width,
			int Height, int FrameRate) throws IOException {
		c.unlock();
		m_recorder.setAudioSource(MediaRecorder.AudioSource.MIC);
		m_recorder.setVideoSource(MediaRecorder.VideoSource.CAMERA);
		m_recorder.setOutputFormat(MediaRecorder.OutputFormat.THREE_GPP);
		m_recorder.setAudioEncoder(MediaRecorder.AudioEncoder.AMR_NB);
		m_recorder.setVideoEncoder(MediaRecorder.VideoEncoder.MPEG_4_SP);
		m_recorder.setOutputFile("/sdcard/" + Filename);
		m_recorder.setVideoSize(Width, Height);
		m_recorder.setVideoFrameRate(FrameRate);
		m_recorder.setPreviewDisplay(sv.getHolder().getSurface());
		m_recorder.prepare();

	}

	/**
	 * starts the video recorder.
	 * 
	 */
	public void startRecorder() {

		isRecording = true;
		try {
			m_recorder.start();

		} catch (IllegalStateException e) {
			e.printStackTrace();
		}
	}

	/**
	 * stops the video recorder.
	 * 
	 */
	public void stopRecorder() {

		isRecording = false;

		m_recorder.stop();
		m_recorder.release();

	}

	/**
	 * boolean if recording.
	 * 
	 */
	public boolean isRecording() {
		return isRecording;

	}

	/**
	 * Releases the camera object and allows other processes to access the
	 * camera.
	 */
	public void Release() {
		if (sv != null) {
			ViewGroup vg = (ViewGroup) sv.getParent();
			vg.removeView(sv);
			sv = null;
		}
		if (c != null) {
			c.release();
			c = null;
		}
	}

	/**
	 * Takes a picture. When the picture is ready, the PictureTaken event will
	 * be raised. You should not call TakePicture while another picture is
	 * currently taken. The preview images are stopped after calling this
	 * method. You can call StartPreview to restart the preview images.
	 */
	public void TakePicture() {
        c.takePicture(null , null, new Camera.PictureCallback() {

            @Override
            public void onPictureTaken(byte[] data, Camera camera) {
                ba.raiseEvent(null, eventName + "_picturetaken", data);
            }
            
        });
    }
	
	/**
	 * Takes a picture and rotates it. When the picture is ready, the PictureTaken2 event will
	 * be raised. You should not call TakePicture while another picture is
	 * currently taken. The preview images are stopped after calling this
	 * method. You can call StartPreview to restart the preview images.
	 * 
	 * degrees: the amount of degrees the bitmap should be turned.
	 * asBitmap: whether you want to retrieve the bitmap (true) or bytearray (false).
	 */
	public void TakePicture2(final float degrees) {
        c.takePicture(null , null, new Camera.PictureCallback() {

            @Override
            public void onPictureTaken(byte[] data, Camera camera) {
            	
            		Bitmap bitmapOrg = BitmapFactory.decodeByteArray(data, 0, data.length);
                	Matrix matrix = new Matrix();
                	matrix.postRotate(degrees);
                	Bitmap newBitmap = Bitmap.createBitmap(bitmapOrg, 0, 0, bitmapOrg.getWidth(), bitmapOrg.getHeight(), matrix, true);
                	ByteArrayOutputStream bos = new ByteArrayOutputStream(); 
                	newBitmap.compress(CompressFormat.PNG, 0, bos); 
                	byte[] bitmapdata = bos.toByteArray();
                    ba.raiseEvent(null, eventName + "_picturetaken2", bitmapdata);

            }
            
        });
        
    }

	/**
	 * Use the back camera as primary.
	 * Old
	 */

	public void CameraBack() {
		Camera.Parameters params = c.getParameters();
		params.set("camera-id", Camera.CameraInfo.CAMERA_FACING_BACK);
		c.setParameters(params);

	}
	
	/**
	 * Use the back camera as primary.
	 * 
	 */

	public void CameraBack2() {
		Camera.Parameters params = c.getParameters();
		Camera.open(Camera.CameraInfo.CAMERA_FACING_BACK);
		c.setParameters(params);

	}
	
	/**
	 * Use the front camera as primary.
	 * 
	 */

	public void CameraFront2() {
		Camera.Parameters params = c.getParameters();
		Camera.open(Camera.CameraInfo.CAMERA_FACING_FRONT);
		c.setParameters(params);

	}
	
	/**
	 * Since api 2.3
	 * @return
	 */
	public Camera openFrontFacingCameraGingerbread() 
	{
	    int cameraCount = 0;
	    Camera cam = null;
	    Camera.CameraInfo cameraInfo = new Camera.CameraInfo();
	    cameraCount = Camera.getNumberOfCameras();
	    for ( int camIdx = 0; camIdx < cameraCount; camIdx++ ) {
	        Camera.getCameraInfo( camIdx, cameraInfo );
	        if ( cameraInfo.facing == Camera.CameraInfo.CAMERA_FACING_FRONT  ) {
	            try {
	                cam = Camera.open( camIdx );
	            } catch (RuntimeException e) {
	                Log.e("B4A", "Camera failed to open: " + e.getLocalizedMessage());
	            }
	        }
	    }

	    return cam;
	}

	/**
	 * Removes the attached GPS Data.
	 * 
	 * 
	 */
	public void removeGPSData() {
		Camera.Parameters params = c.getParameters();
		params.removeGpsData();
		c.setParameters(params);
	}
	
	/**
	 * Sets GPS altitude.
	 * 
	 * 
	 */
	public void setGPSAltitude(Double Altitude) {
		Camera.Parameters params = c.getParameters();
		params.setGpsAltitude(Altitude);
		c.setParameters(params);
	}
	
	/**
	 * Sets GPS latitude coordinate. This will be stored in JPEG EXIF header.
	 * 
	 * 
	 */
	public void setGPSLatitude(Double Latitude) {
		Camera.Parameters params = c.getParameters();
		params.setGpsLatitude(Latitude);
		c.setParameters(params);
	}
	
	/**
	 * Sets GPS timestamp. This will be stored in JPEG EXIF header.
	 * 
	 * timestamp	GPS timestamp (UTC in seconds since January 1, 1970).
	 * 
	 */
	public void setGPSTimeStamp(long timestamp) {
		Camera.Parameters params = c.getParameters();
		params.setGpsTimestamp(timestamp);
		c.setParameters(params);
	}
	
	/**
	 * Sets GPS longitude coordinate. This will be stored in JPEG EXIF header.
	 * 
	 * 
	 */
	public void setGPSLongitude(Double Longitude) {
		Camera.Parameters params = c.getParameters();
		params.setGpsLatitude(Longitude);
		c.setParameters(params);
	}
	
	/**
	 * Use the front camera as primary.
	 * 
	 * @return 
	 */
	public void CameraFront() {
		Camera.Parameters params = c.getParameters();
		params.set("camera-id", Camera.CameraInfo.CAMERA_FACING_FRONT);
		c.setParameters(params);
	}
	
	
	


	/**
	 * Sets the camera orientation to portrait.
	 */
	public void OriPortrait() {
		Camera.Parameters params = c.getParameters();
		c.setDisplayOrientation(90);
		c.setParameters(params);

	}

	/**
	 * Sets the camera orientation to landscape.
	 */
	public void OriLandscape() {
		Camera.Parameters params = c.getParameters();
		c.setDisplayOrientation(0);
		c.setParameters(params);

	}
	
	/**
	 * Sets the camera orientation to portrait.
	 * API Level 8 and down
	 */
	public void OriPortraitAPI8() {
		Camera.Parameters params = c.getParameters();
		params.set("orientation", "portrait");
		c.setParameters(params);

	}

	/**
	 * Sets the camera orientation to landscape.
	 * API Level 8 and down
	 */
	public void OriLandscapeAPI8() {
		Camera.Parameters params = c.getParameters();
		params.set("orientation", "landscape");
		c.setParameters(params);

	}

	/**
	 * Sets the exposure compensation. A technique for adjusting the exposure
	 * indicated by a photographic exposure meter.
	 */
	public void setExposureCompensation(int value) {
		Camera.Parameters params = c.getParameters();
		params.setExposureCompensation(value);
		c.setParameters(params);

	}
	
	/**
	 * Gets the exposure compensation. A technique for adjusting the exposure
	 * indicated by a photographic exposure meter.
	 */
	public int getExposureCompensation() {
		Camera.Parameters params = c.getParameters();
		return params.getExposureCompensation();

	}
	
	/**
	 * Gets the supported Preview FPS Range.a list of supported preview fps ranges. 
	 * This method returns a list with at least one element. 
	 * Every element is an int array of two values - minimum fps and maximum fps. 
	 * The list is sorted from small to large (first by maximum fps and then minimum fps).
	 */
	public List<int[]> getSupportedPreviewFpsRange() {
		Camera.Parameters params = c.getParameters();
		return params.getSupportedPreviewFpsRange();

	}
	/**
	 * Sets the supported Preview FPS Range.a list of supported preview fps ranges. 
	 * This method returns a list with at least one element. 
	 * Every element is an int array of two values - minimum fps and maximum fps. 
	 * The list is sorted from small to large (first by maximum fps and then minimum fps).
	 */
	public void setPreviewFpsRange (int min, int max) {
		Camera.Parameters params = c.getParameters();
		params.setPreviewFpsRange(min, max);
		c.setParameters(params);
		
	}
	
	/**
	 * Gets or sets the current Preview frame rate.
	 */
	public int getPreviewFrameRate () {
		Camera.Parameters params = c.getParameters();
		return params.getPreviewFrameRate();

	}
	/**
	 * Gets the supported Preview frame rate.
	 */
	public List<Integer> getSupportedPreviewFrameRates (){
	Camera.Parameters params = c.getParameters();
	return params.getSupportedPreviewFrameRates();

	}
	/**
	 * Sets the supported Preview Frame Rate.
	 */
	public void setPreviewFrameRate (int fps) {
		Camera.Parameters params = c.getParameters();
		params.setPreviewFrameRate(fps);
		c.setParameters(params);
		
	}

	/**
	 * Sets the iso value. Note that this MIGHT not work (properly).
	 */
	public void setISOValue(int value) {
		Camera.Parameters params = c.getParameters();
		params.set("iso", value);
		c.setParameters(params);
	}

	/**
	 * Sets the size of the picture in pixels.
	 */
	public void PictureSize(int width, int height) {
		Camera.Parameters params = c.getParameters();
		params.setPictureSize(width, height);
		c.setParameters(params);

	}

	/**
	 * Sets the zooming level.
	 */
	public void setZoom(int value) {
		Camera.Parameters params = c.getParameters();
		String zoomSupportedString = params.get("zoom-supported");
		if (zoomSupportedString != null
				&& !Boolean.parseBoolean(zoomSupportedString)) {
			params.setZoom(value);
			c.setParameters(params);
		}

	}

	/**
	 * Returns the maximum zooming level. 0 is no zooming supported.
	 * 
	 * @return
	 */
	public int getMaxZoom() {
		Camera.Parameters params = c.getParameters();
		return params.getMaxZoom();
	}

	/**
	 * Returns the maximum exposure compensation.
	 * 
	 * @return
	 */
	public int getMaxExposureCompensation() {
		Camera.Parameters params = c.getParameters();
		return params.getMaxExposureCompensation();
	}

	/**
	 * Returns the minimum exposure compensation.
	 * 
	 * @return
	 */
	public int getMinExposureCompensation() {
		Camera.Parameters params = c.getParameters();
		return params.getMinExposureCompensation();
	}

	/**
	 * Returns a list of all supported colour effects.
	 * 
	 * @return
	 */
	public List<String> getSupportedColourEffect() {
		Camera.Parameters params = c.getParameters();
		return params.getSupportedColorEffects();
	}

	/**
	 * Returns the current colour effect. (String)
	 * 
	 * @return
	 */
	public String getCurrentColourEffect() {
		Camera.Parameters params = c.getParameters();
		return params.getColorEffect();
	}

	/**
	 * Returns a list of all supported focus modes.
	 * 
	 * @return
	 */
	public List<String> getSupportedFocusMode() {
		Camera.Parameters params = c.getParameters();
		return params.getSupportedFocusModes();
	}

	/**
	 * Returns the current focus mode. (String)
	 * 
	 * @return
	 */
	public String getCurrentFocusMode() {
		Camera.Parameters params = c.getParameters();
		return params.getFocusMode();
	}

	/**
	 * Returns a list of all supported picture sizes.
	 * 
	 * @return
	 */
	public List<Size> getSupportedPictureSize() {
		Camera.Parameters params = c.getParameters();
		return params.getSupportedPictureSizes();
	}

	/**
	 * Returns the current picture size. (Size)
	 * 
	 * @return
	 */
	public Size getCurrentPictureSize() {
		Camera.Parameters params = c.getParameters();
		return params.getPictureSize();
	}

	/**
	 * Returns a list of all supported scene modes.
	 * 
	 * @return
	 */
	public List<String> getSupportedSceneMode() {
		Camera.Parameters params = c.getParameters();
		return params.getSupportedSceneModes();
	}

	/**
	 * Returns the current scene mode. (String)
	 * 
	 * @return
	 */
	public String getCurrentSceneMode() {
		Camera.Parameters params = c.getParameters();
		return params.getSceneMode();
	}

	/**
	 * Returns a list of all supported white balances.
	 * 
	 * @return
	 */
	public List<String> getSupportedWhiteBalance() {
		Camera.Parameters params = c.getParameters();
		return params.getSupportedWhiteBalance();
	}

	/**
	 * Returns the current white balance. (String)
	 * 
	 * @return
	 */
	public String getCurrentWhiteBalance() {
		Camera.Parameters params = c.getParameters();
		return params.getWhiteBalance();
	}

	/**
	 * Returns a list of all supported flash modes.
	 * 
	 * @return
	 */
	public List<String> getSupportedFlashMode() {
		Camera.Parameters params = c.getParameters();
		return params.getSupportedFlashModes();
	}

	/**
	 * Returns the current flash mode. (String)
	 * 
	 * @return
	 */
	public String getCurrentFlashMode() {
		Camera.Parameters params = c.getParameters();
		return params.getFlashMode();
	}

	/**
	 * Returns a list of all supported antibandings.
	 * 
	 * @return
	 */
	public List<String> getSupportedAntibanding() {
		Camera.Parameters params = c.getParameters();
		return params.getSupportedAntibanding();
	}

	/**
	 * Returns the current antibanding. (String)
	 * 
	 * @return
	 */
	public String getCurrentAntibanding() {
		Camera.Parameters params = c.getParameters();
		return params.getAntibanding();
	}
	
	/**
	 * Gets the focal length (in millimeter) of the camera.
	 * Returns the focal length. This method will always return a valid value.
	 */
	public float getFocalLength (){
		Camera.Parameters params = c.getParameters();
		return params.getFocalLength();
	}
	
	/**
	 * Gets the horizontal angle of view in degrees.
	 * Returns horizontal angle of view. This method will always return a valid value.
	 */
	public float getHorizontalViewAngle (){
		Camera.Parameters params = c.getParameters();
		return params.getHorizontalViewAngle();
		
	}
	
	/**
	 * Gets the vertical angle of view in degrees.
	 * Returns vertical angle of view. This method will always return a valid value.
	 */
	public float getVerticalViewAngle (){
		Camera.Parameters params = c.getParameters();
		return params.getVerticalViewAngle();
		
	}

	/**
	 * Sets the quality of the JPEG file. The range is between 1 to 100, with
	 * 100 being the best.
	 */
	public void setQuality(int quality) {
		Camera.Parameters params = c.getParameters();
		params.setJpegQuality(quality);
		c.setParameters(params);

	}
	
	/**
	 * Returns a list of all supported Picture Formats.
	 * 
	 * @return
	 */
	public List<Integer> getSupportedPictureFormats() {
		Camera.Parameters params = c.getParameters();
		return params.getSupportedPictureFormats();
	}
	
	/**
	 * Returns the image format for preview frames got from Camera.PreviewCallback.
	 * 
	 * @return
	 */
	public int getPreviewFormat() {
		Camera.Parameters params = c.getParameters();
		return params.getPreviewFormat();
	
	}

	/**
	 * Returns a true or false statement when zooming is supported or not.
	 * 
	 * @return
	 */
	public boolean isZoomSupported() {
		Camera.Parameters params = c.getParameters();
		String zoomSupportedString = params.get("zoom-supported");
		if (zoomSupportedString != null
				&& !Boolean.parseBoolean(zoomSupportedString)) {
			return false;
		} else {
			return true;
		}

	}

	/**
	 * Enables the flashlight to turn on automatically.
	 */
	public void FlashAuto() {
		Camera.Parameters params = c.getParameters();
		params.setFlashMode(Camera.Parameters.FLASH_MODE_AUTO);
		c.setParameters(params);
	}

	/**
	 * Turns the flashlight on (Torch Mode).
	 */
	public void FlashTorch() {
		Camera.Parameters params = c.getParameters();
		params.setFlashMode(Camera.Parameters.FLASH_MODE_TORCH);
		c.setParameters(params);
	}
	
	/**
	 * Turns the flashlight on.
	 */
	public void FlashOn() {
		Camera.Parameters params = c.getParameters();
		params.setFlashMode(Camera.Parameters.FLASH_MODE_ON);
		c.setParameters(params);
	}

	/**
	 * Turns the flashlight off.
	 */
	public void FlashOff() {
		Camera.Parameters params = c.getParameters();
		params.setFlashMode(Camera.Parameters.FLASH_MODE_OFF);
		c.setParameters(params);
	}

	/**
	 * Sets the focus mode. MACRO: Close-up, INFINITY: Far distance. FIXED: If
	 * the camera has auto-focus, this mode can fix the focus. AUTO: Auto-focus
	 * mode, EDOF: Focusing is done digitally and continuously. For example:
	 * Camera1.setFocusMode = "MACRO"
	 * 
	 */
	public void setFocusMode(String Focusmode) {

		Camera.Parameters params = c.getParameters();
		if (Focusmode.equals("MACRO")) {
			c.autoFocus(mAutofocusCallback);
			params.setFocusMode(Parameters.FOCUS_MODE_MACRO);
			c.setParameters(params);
		}
		if (Focusmode.equals("INFINITY")) {
			params.setFocusMode(Parameters.FOCUS_MODE_INFINITY);
			c.setParameters(params);
		}
		if (Focusmode.equals("FIXED")) {
			params.setFocusMode(Parameters.FOCUS_MODE_FIXED);
			c.setParameters(params);
		}
		if (Focusmode.equals("AUTO")) {
			c.autoFocus(mAutofocusCallback);
			params.setFocusMode(Camera.Parameters.FOCUS_MODE_AUTO);
			c.setParameters(params);
		}
		if (Focusmode.equals("EDOF")) {
			params.setFocusMode(Camera.Parameters.FOCUS_MODE_EDOF);
			c.setParameters(params);
		}

	}

	AutoFocusCallback mAutofocusCallback = new AutoFocusCallback() {

		@Override
		public void onAutoFocus(boolean arg0, Camera arg1) {
			// TODO Auto-generated method stub

		}
	};
	
	/**
	 * Detect faces in a picture.
	 * It makes a red rectangle around the face.
	 * Filename = the name of the file that will be saved with the rectangles on the SD Card.
	 * Bitmap = mutable or immutable bitmap image
	 * Width = bitmap width
	 * Height = bitmap height
	 * maxFaces = the maximum amount of faces to look for.
	 * Dim btmp As Bitmap
	 * btmp.Initialize(File.DirRootExternal,"faces_2004W_comp1.jpg")
	 * Camera1.detectFaces("detectedFace",btmp,btmp.Width,btmp.Height,43)
	 * 
	 */
	public void detectFaces(String Dir, String Filename,Bitmap bitmap,int Width, int Height,int maxFaces){
		Log.i("B4A","FaceDetect: Called");
        //if(null != cameraBitmap){
			Log.i("B4A","Bitmap Config: " + bitmap.getConfig());
                int width = Width;
                int height = Height;
                Log.i("B4A","Width: " + width);
                Log.i("B4A","Height: " + height);
                
                FaceDetector detector = new FaceDetector(width, height,maxFaces);
                Face[] faces = new Face[maxFaces];
                
                Bitmap bitmapold = Bitmap.createBitmap(bitmap, 0, 0, width, height);
                Bitmap bitmap565 = bitmapold.copy(Config.RGB_565, true);
                //Log.i("B4A","Bitmap Config: " + bitmap.getConfig());
                Log.i("B4A","Bitmap Create.");
                Paint ditherPaint = new Paint();
                Paint drawPaint = new Paint();
                Log.i("B4A","New Paint");
                ditherPaint.setDither(true);
                drawPaint.setColor(Color.RED);
                drawPaint.setStyle(Paint.Style.STROKE);
                drawPaint.setStrokeWidth(2);
                Log.i("B4A","New Canvas.");
                
                Canvas canvas = new Canvas();
                Log.i("B4A","Canvas made.");
                canvas.setBitmap(bitmap565);
                canvas.drawBitmap(bitmap565, 0, 0, ditherPaint);
                Log.i("B4A","Draw Bitmap.");
                
                int facesFound = detector.findFaces(bitmap565, faces);
                PointF midPoint = new PointF();
                float eyeDistance = 0.0f;
                float confidence = 0.0f;
                FDdetectedfaces = facesFound;
                Log.i("B4A", "Number of faces found: " + facesFound);
                
                if(facesFound > 0)
                {
                        for(int index=0; index<facesFound; ++index){
                                // Get the eye distance, detected eye mid point and confidence
                                faces[index].getMidPoint(midPoint);
                                eyeDistance = faces[index].eyesDistance();
                                confidence = faces[index].confidence();
                                
                                FDconfidence = confidence;
                                FDeyedistance = eyeDistance;
                                FDmidpointx = midPoint.x;
                                FDmidpointy = midPoint.y;
                                Log.i("B4A", 
                                                "Confidence: " + confidence + 
                                                ", Eye distance: " + eyeDistance + 
                                                ", Mid Point: (" + midPoint.x + ", " + midPoint.y + ")");
                                
                                // Draw a small rectangle frame around the eye 
                                canvas.drawRect((int)midPoint.x - 2*eyeDistance , 
                                                                (int)midPoint.y - 2*eyeDistance , 
                                                                (int)midPoint.x + 2*eyeDistance, 
                                                                (int)midPoint.y + 2*eyeDistance, drawPaint);
                        }
                }
                
                String filepath = Dir + "/" + Filename;
                
                        try {
                                FileOutputStream fos = new FileOutputStream(filepath);
                                
                                bitmap565.compress(CompressFormat.JPEG, 90, fos);
                                
                                fos.flush();
                                fos.close();
                        } catch (FileNotFoundException e) {
                                e.printStackTrace();
                        } catch (IOException e) {
                                e.printStackTrace();
                        }
                       
                        Log.i("B4A","Finished.");
                        
        }
    //}
	
	/**
	 * Returns a confidence factor between 0 and 1. 
	 * This indicates how certain what has been found is actually a face. 
	 * A confidence factor above 0.3 is usually good enough.
	 * Given by the last found face.
	 * 
	 */
	public float getFaceConfidence() {
		return FDconfidence;
	}
	
	/**
	 * Returns the distance between the eyes.
	 * Given by the last found face.
	 * 
	 */
	public float getFaceEyesDistance() {
		return FDeyedistance;
	}
	
	/**
	 * Returns all found faces on the picture
	 * Given by the last found face.
	 * 
	 */
	public int getFaceFound() {
		return FDdetectedfaces;
	}
	
	/**
	 * Returns the midpoint of the eyes on the x-axis.
	 * Given by the last found face.
	 * 
	 */
	public float getFaceMidPointX() {
		return FDmidpointx;
	}
	
	/**
	 * Returns the midpoint of the eyes on the y-axis.
	 * Given by the last found face.
	 * 
	 */
	public float getFaceMidPointY() {
		return FDmidpointy;
	}
	
	/**
	 * Returns the face's pose. 
	 * That is, the rotations around either the X, Y or Z axis 
	 * (the positions in 3-dimensional Euclidean space).
	 * Euler:
	 * EULER_X, EULER_Y or EULER_Z
	 * 
	 */
	public float pose(int euler) {
		// don't use an array to avoid allocations
		if (euler == EULER_X)
			return mPoseEulerX;
		else if (euler == EULER_Y)
			return mPoseEulerY;
		else if (euler == EULER_Z)
			return mPoseEulerZ;
		throw new IllegalArgumentException();
		}
	
	
	
	/**
	 * Sets the dimensions for preview pictures. The sides of width and height are based on camera orientation. 
	 * That is, the preview size is the size before it is rotated by display orientation. So applications need 
	 * to consider the display orientation while setting preview size. For example, suppose the camera supports 
	 * both 480x320 and 320x480 preview sizes. The application wants a 3:2 preview ratio. If the display orientation 
	 * is set to 0 or 180, preview size should be set to 480x320. If the display orientation is set to 90 or 270, 
	 * preview size should be set to 320x480. The display orientation should also be considered while setting picture 
	 * size and thumbnail size.
	 */
	public void setResolution(int width, int height) {
		Camera.Parameters params = c.getParameters();
		params.setPreviewSize(width, height);
		c.setParameters(params);
	}
	
	/**
	 * Gets the picture on the current frame.
	 * Width: the width of the picture.
	 * Height: the height of the picture
	 * Quality: the quality of the jpeg image.
	 * Calls _PreviewTaken when finished.
	 * 
	 */
	public void getPictureOnCurrentFrame(int Width, int Height, int Quality){
		FrameWidth = Width;
		FrameHeight = Height;
		FrameQuality = Quality;
		try {
				
			isDecoding = true;
			c.setOneShotPreviewCallback(this);		
		} catch (Exception e) {
		}		
	}

	@Override
	public void onPreviewFrame(byte[] data, Camera camera) {
			Camera.Parameters cp = c.getParameters();
			Size sz = cp.getPreviewSize();
			int width = sz.width; //FrameWidth;
			int height = sz.height; //FrameHeight;
			int quality = FrameQuality;

        int[] temp = new int[width*height];
        OutputStream outptstream = new ByteArrayOutputStream();
        Bitmap bm = null;
        
        decodeYUV420SP(temp, data, width, height);
        bm = Bitmap.createBitmap(temp, width, height, Bitmap.Config.RGB_565);
        bm.compress(CompressFormat.JPEG, quality, outptstream);
        CurrentJPEG = ((ByteArrayOutputStream)outptstream).toByteArray();
		isDecoding = false;
			Log.i("B4A", "isDecoding false");
	    ba.raiseEvent(this, eventName + "_previewtaken", new Object[] { CurrentJPEG } );
}
	
	/**
	 * Converts raw data to jpg.
	 * 
	 */
	public void decodeYUV420SP(int[] rgb, byte[] yuv420sp, int width, int height)
    {
		final int frameSize = width * height;   
  
        for (int j = 0, yp = 0; j < height; j++) {   
            int uvp = frameSize + (j >> 1) * width, u = 0, v = 0;   
            for (int i = 0; i < width; i++, yp++) {   
                int y = (0xff & ((int) yuv420sp[yp])) - 16;   
                if (y < 0) y = 0;   
                if ((i & 1) == 0) {   
                    v = (0xff & yuv420sp[uvp++]) - 128;   
                    u = (0xff & yuv420sp[uvp++]) - 128;   
                }   

                int y1192 = 1192 * y;   
                int r = (y1192 + 1634 * v);   
                int g = (y1192 - 833 * v - 400 * u);   
                int b = (y1192 + 2066 * u);   

                if (r < 0) r = 0; else if (r > 262143) r = 262143;   
                if (g < 0) g = 0; else if (g > 262143) g = 262143;   
                if (b < 0) b = 0; else if (b > 262143) b = 262143;   

                rgb[yp] = 0xff000000 | ((r << 6) & 0xff0000) | ((g >> 2) &    
        0xff00) | ((b >> 10) & 0xff);   

                }
        }
    }
	
	/**
	 * Encodes a bytearray image with Base64 and uploads it to a web client that supports PHP.
	 * @param WebClient a string referring to your base.php file (http://IP:Port/base.php)
	 * e.g. "http://192.168.1.100/android/base.php, "http://www.mywebsite.com/index.php
	 * 
	 * PHPProtect is a small password protection to check on your websserver
	 * Webserver: "image" = frame
	 * Webserver: "PHPProtect" = FrameProtect
	 * 
	 * 
	 */
	public void uploadFrame(String PHPProtect, byte[] Frame, String WebClient) {
		FrameProtect = PHPProtect;
		Log.i("B4A", "UploadFrame Called");
		String ba1=Base64.encodeBytes(Frame);
        ArrayList<NameValuePair> nameValuePairs = new
        ArrayList<NameValuePair>();
           nameValuePairs.add(new BasicNameValuePair("image",ba1));
           nameValuePairs.add(new BasicNameValuePair("PHPProtect",FrameProtect));
           
          
           try{

               HttpPost httppost = new
               HttpPost(WebClient);
               httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));
               HttpResponse response = httpclient.execute(httppost);
               HttpEntity entity = response.getEntity();
               is = entity.getContent();
               Log.i("B4A", "Problem");
               ba.raiseEvent(this, eventName + "_finishedstream", new Object[] { ba1 } );
               Log.i("B4A", "Problem solved");
         }catch(Exception e){
               Log.e("log_tag", "Error in http connection "+e.toString());
         }
	}
	
	/**
	 * A trial for your app.
	 * Sends a HTTP POST method to the webserver.
	 * FrameProtect = Small Password Protection
	 * WebServer = URL to listening PHP file
	 * IMEI = The Device IMEI
	 * Period = the amount that the app can be opened.
	 * 
	 * Listen on Webserver for:
	 * "PHPProtect"
	 * "IMEI"
	 * "TrialPeriod"
	 */
	public void AppTrial(String FrameProtect, String WebServer, String IMEI, String Period) {
		Log.i("B4A", "Stop");
        ArrayList<NameValuePair> nameValuePairs = new
        ArrayList<NameValuePair>();
           nameValuePairs.add(new BasicNameValuePair("PHPProtect",FrameProtect));
           nameValuePairs.add(new BasicNameValuePair("IMEI",IMEI));
           nameValuePairs.add(new BasicNameValuePair("TrialPeriod",Period));
           try{

               HttpPost httppost = new
               HttpPost(WebServer);
               httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));
               HttpResponse response = httpclient.execute(httppost);
               HttpEntity entity = response.getEntity();
               is = entity.getContent();
           
         }catch(Exception e){
               Log.e("log_tag", "Error in http connection "+e.toString());
         }
	}
	

	/**
	 * Returns current frame.
	 * 
	 */
	public byte[] currentFrame() {

		return CurrentJPEG;

	}
	/**
	 * If there is an available frame.
	 * 
	 */
	public boolean getAvailableFrame() {

		return mAvailableFrame;

	}
	/**
	 * returns true if frame is decoding.
	 * 
	 */
	public boolean getisDecoding () {
		
		return isDecoding;
	}
	

	/**
	 * Sets the Scene Mode. ACTION: Take photos of fast moving objects., AUTO:
	 * Scene mode is off. BEACH: Take pictures on the beach CANDLELIGHT: Capture
	 * scenes lit by candles, FIREWORKS: Take pictures of fireworks. LANDSCAPE:
	 * Take pictures on distant objects., NIGHT: Take photos at night. PARTY:
	 * Indoor low-light shot., PORTRAIT: Take people pictures. SNOW: in the
	 * snow., STEADYPHOTO: Avoid blurry pictures (handshake). SUNSET: Take
	 * Sunset photos., THEATRE: Take photos in a theater. For example:
	 * Camera1.setScene = "BEACH"
	 * 
	 */
	public void setSceneMode(String SceneMode) {
		Camera.Parameters params = c.getParameters();
		if (SceneMode.equals("ACTION")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_ACTION);
			c.setParameters(params);
		}
		if (SceneMode.equals("AUTO")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_AUTO);
			c.setParameters(params);
		}
		if (SceneMode.equals("BEACH")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_BEACH);
			c.setParameters(params);
		}
		if (SceneMode.equals("CANDLELIGHT")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_CANDLELIGHT);
			c.setParameters(params);
		}
		if (SceneMode.equals("FIREWORKS")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_FIREWORKS);
			c.setParameters(params);
		}
		if (SceneMode.equals("LANDSCAPE")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_LANDSCAPE);
			c.setParameters(params);
		}
		if (SceneMode.equals("NIGHT")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_NIGHT);
			c.setParameters(params);
		}
		if (SceneMode.equals("NIGHT_PORTRAIT")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_NIGHT);
			c.setParameters(params);
		}
		if (SceneMode.equals("PARTY")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_PARTY);
			c.setParameters(params);
		}
		if (SceneMode.equals("PORTRAIT")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_PORTRAIT);
			c.setParameters(params);
		}
		if (SceneMode.equals("SNOW")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_SNOW);
			c.setParameters(params);
		}
		if (SceneMode.equals("STEADYPHOTO")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_STEADYPHOTO);
			c.setParameters(params);
		}
		if (SceneMode.equals("SUNSET")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_SUNSET);
			c.setParameters(params);
		}
		if (SceneMode.equals("THEATRE")) {
			params.setSceneMode(Camera.Parameters.SCENE_MODE_THEATRE);
			c.setParameters(params);
		}
	}

	/**
	 * Sets the Antibanding. ANTIBANDING_50HZ: Sets the antibanding to 50Hz.
	 * ANTIBANDING_60HZ: Sets the antibanding to 60Hz. ANTIBANDING_AUTO: Sets
	 * the antibanding to automatic mode. ANTIBANDING_OFF: Sets the antibanding
	 * off. For example: Camera1.setAntibanding = "ANTIBANDING_AUTO"
	 */
	public void setAntibanding(String Antibanding) {
		Camera.Parameters params = c.getParameters();
		if (Antibanding.equals("ANTIBANDING_50HZ")) {
			params.setAntibanding(Camera.Parameters.ANTIBANDING_50HZ);
			c.setParameters(params);
		}
		if (Antibanding.equals("ANTIBANDING_60HZ")) {
			params.setAntibanding(Camera.Parameters.ANTIBANDING_60HZ);
			c.setParameters(params);
		}
		if (Antibanding.equals("ANTIBANDING_AUTO")) {
			params.setAntibanding(Camera.Parameters.ANTIBANDING_AUTO);
			c.setParameters(params);
		}
		if (Antibanding.equals("ANTIBANDING_OFF")) {
			params.setAntibanding(Camera.Parameters.ANTIBANDING_OFF);
			c.setParameters(params);
		}
	}

	/**
	 * Sets the color effect of a picture. The following effects are: AQUA,
	 * BLACKBOARD, MONO, NEGATIVE, NONE, POSTERIZE, SEPIA, SOLARIZE, WHITEBOARD.
	 * For example: Camera1.setColourEffect = "SEPIA"
	 */
	public void setColourEffect(String Effect) {
		Camera.Parameters params = c.getParameters();
		if (Effect.equals("AQUA")) {
			params.setColorEffect(Camera.Parameters.EFFECT_AQUA);
			c.setParameters(params);
		}
		if (Effect.equals("BLACKBOARD")) {
			params.setColorEffect(Camera.Parameters.EFFECT_BLACKBOARD);
			c.setParameters(params);
		}
		if (Effect.equals("MONO")) {
			params.setColorEffect(Camera.Parameters.EFFECT_MONO);
			c.setParameters(params);
		}
		if (Effect.equals("NEGATIVE")) {
			params.setColorEffect(Camera.Parameters.EFFECT_NEGATIVE);
			c.setParameters(params);
		}
		if (Effect.equals("NONE")) {
			params.setColorEffect(Camera.Parameters.EFFECT_NONE);
			c.setParameters(params);
		}
		if (Effect.equals("POSTERIZE")) {
			params.setColorEffect(Camera.Parameters.EFFECT_POSTERIZE);
			c.setParameters(params);
		}
		if (Effect.equals("SEPIA")) {
			params.setColorEffect(Camera.Parameters.EFFECT_SEPIA);
			c.setParameters(params);
		}
		if (Effect.equals("SOLARIZE")) {
			params.setColorEffect(Camera.Parameters.EFFECT_SOLARIZE);
			c.setParameters(params);
		}
		if (Effect.equals("WHITEBOARD")) {
			params.setColorEffect(Camera.Parameters.EFFECT_WHITEBOARD);
			c.setParameters(params);
		}
	}

	/**
	 * Sets the white balance. The following effects are: AUTO, CLOUDY_DAYLIGHT,
	 * DAYLIGHT, FLUORESCENT, INCANDESCENT, SHADE, TWILIGHT, WARM_FLUORESCENT.
	 * For example: Camera1.setEffect = "WARM_FLUORESCENT"
	 */
	public void setWhiteBalance(String Balance) {
		Camera.Parameters params = c.getParameters();
		if (Balance.equals("AUTO")) {
			params.setWhiteBalance(Camera.Parameters.WHITE_BALANCE_AUTO);
			c.setParameters(params);
		}
		if (Balance.equals("CLOUDY_DAYLIGHT")) {
			params.setWhiteBalance(Camera.Parameters.WHITE_BALANCE_CLOUDY_DAYLIGHT);
			c.setParameters(params);
		}
		if (Balance.equals("DAYLIGHT")) {
			params.setWhiteBalance(Camera.Parameters.WHITE_BALANCE_DAYLIGHT);
			c.setParameters(params);
		}
		if (Balance.equals("FLUORESCENT")) {
			params.setWhiteBalance(Camera.Parameters.WHITE_BALANCE_FLUORESCENT);
			c.setParameters(params);
		}
		if (Balance.equals("INCANDESCENT")) {
			params.setWhiteBalance(Camera.Parameters.WHITE_BALANCE_INCANDESCENT);
			c.setParameters(params);
		}
		if (Balance.equals("SHADE")) {
			params.setWhiteBalance(Camera.Parameters.WHITE_BALANCE_SHADE);
			c.setParameters(params);
		}
		if (Balance.equals("TWILIGHT")) {
			params.setWhiteBalance(Camera.Parameters.WHITE_BALANCE_TWILIGHT);
			c.setParameters(params);
		}
		if (Balance.equals("WARM_FLUORESCENT")) {
			params.setWhiteBalance(Camera.Parameters.WHITE_BALANCE_WARM_FLUORESCENT);
			c.setParameters(params);
		}
	}

}
